Index: branches/ALPS/HeuristicLab.Algorithms.ALPS.SteadyState/3.3/AlpsSsGeneticAlgorithm.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS.SteadyState/3.3/AlpsSsGeneticAlgorithm.cs	(revision 12259)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS.SteadyState/3.3/AlpsSsGeneticAlgorithm.cs	(revision 12270)
@@ -143,6 +143,6 @@
       var initializeAgeProcessor = new UniformSubScopesProcessor();
       var initializeAge = new VariableCreator() { Name = "Initialize Age" };
-      var initializeEvaluatedSolutions = new ExpressionCalculator() { Name = "Initialize EvaluatedSolutions" };
-      var initializeResultEvaluatedSolutions = new Assigner() { Name = "Initialize ResultEvaluatedSolutions" };
+      var initializeLocalEvaluatedSolutions = new ExpressionCalculator() { Name = "Initialize local EvaluatedSolutions" };
+      var initializeEvaluatedSolutions = new Assigner() { Name = "Initialize EvaluatedSolutions" };
       var initializePopulationSize = new Assigner() { Name = "Initialize PopulationSize" };
       var resultsCollector = new ResultsCollector();
@@ -155,10 +155,10 @@
       randomCreator.Successor = workingScopeCreator;
 
-      workingScopeCreator.NamesParameter.Value = new StringArray(new[] { "WorkingScope", "LayersScope", "ElitesScope" });
+      workingScopeCreator.NamesParameter.Value = new StringArray(new[] { "WorkingScope", "LayersScope", });
       workingScopeCreator.Successor = layersProcessor;
 
       layersProcessor.TargetScopeParameter.ActualName = "LayersScope";
       layersProcessor.Operator = layerCreator;
-      layersProcessor.Successor = initializeEvaluatedSolutions;
+      layersProcessor.Successor = initializeLocalEvaluatedSolutions;
 
       layerCreator.NumberOfSubScopesParameter.ActualName = "NumberOfLayers";
@@ -183,13 +183,13 @@
       initializeAge.CollectedValues.Add(new ValueParameter<IntValue>("LastMove", new IntValue(1)));
 
-      initializeEvaluatedSolutions.ExpressionResultParameter.ActualName = "EvaluatedSolutions";
-      initializeEvaluatedSolutions.ExpressionParameter.Value = new StringValue("LayerSize NumberOfLayers * toint");
-      initializeEvaluatedSolutions.CollectedValues.Add(new LookupParameter<IntValue>("LayerSize"));
-      initializeEvaluatedSolutions.CollectedValues.Add(new LookupParameter<IntValue>("NumberOfLayers"));
-      initializeEvaluatedSolutions.Successor = initializeResultEvaluatedSolutions;
-
-      initializeResultEvaluatedSolutions.LeftSideParameter.ActualName = "ResultEvaluatedSolutions";
-      initializeResultEvaluatedSolutions.RightSideParameter.ActualName = "EvaluatedSolutions";
-      initializeResultEvaluatedSolutions.Successor = initializePopulationSize;
+      initializeLocalEvaluatedSolutions.ExpressionResultParameter.ActualName = "LocalEvaluatedSolutions";
+      initializeLocalEvaluatedSolutions.ExpressionParameter.Value = new StringValue("LayerSize NumberOfLayers * toint");
+      initializeLocalEvaluatedSolutions.CollectedValues.Add(new LookupParameter<IntValue>("LayerSize"));
+      initializeLocalEvaluatedSolutions.CollectedValues.Add(new LookupParameter<IntValue>("NumberOfLayers"));
+      initializeLocalEvaluatedSolutions.Successor = initializeEvaluatedSolutions;
+
+      initializeEvaluatedSolutions.LeftSideParameter.ActualName = "EvaluatedSolutions";
+      initializeEvaluatedSolutions.RightSideParameter.ActualName = "LocalEvaluatedSolutions";
+      initializeEvaluatedSolutions.Successor = initializePopulationSize;
 
       initializePopulationSize.LeftSideParameter.ActualName = "PopulationSize";
@@ -197,5 +197,5 @@
       initializePopulationSize.Successor = resultsCollector;
 
-      resultsCollector.CollectedValues.Add(new LookupParameter<IntValue>("Evaluated Solutions", null, "ResultEvaluatedSolutions"));
+      resultsCollector.CollectedValues.Add(new LookupParameter<IntValue>("EvaluatedSolutions"));
       resultsCollector.CollectedValues.Add(new ScopeTreeLookupParameter<ResultCollection>("LayerResults", "Result set for each layer", "LayerResults", 2));
       resultsCollector.Successor = mainLoop;
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS.SteadyState/3.3/AlpsSsGeneticAlgorithmMainLoop.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS.SteadyState/3.3/AlpsSsGeneticAlgorithmMainLoop.cs	(revision 12259)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS.SteadyState/3.3/AlpsSsGeneticAlgorithmMainLoop.cs	(revision 12270)
@@ -98,10 +98,10 @@
       var resetTargetIndex = new Assigner() { Name = "TargetIndex = MatingPoolSize" };
       var tryMoveUp = new AlpsSsMover() { Name = "Try Move Up" };
-      var incrementEvaluations = new IntCounter() { Name = "Incr. EvaluatedSolutions" };
+      var incrementLocalEvaluations = new IntCounter() { Name = "Incr. local EvaluatedSolutions" };
       var incrementBatchIterations = new IntCounter() { Name = "Incr. BatchIterations" };
       var batchFinishedComperator = new Comparator() { Name = "BatchFinished = BatchIterations >= BatchSize" };
       var batchFinishedBranch = new ConditionalBranch() { Name = "BatchFinished?" };
       var incrIterations = new IntCounter() { Name = "Incr. Iterations" };
-      var updateResultEvaluatedSolutions = new IntCounter() { Name = "Update ResultEvaluatedSolutions" };
+      var updateEvaluatedSolutions = new IntCounter() { Name = "Update EvaluatedSolutions" };
       var layerAnalyzerProcessor = new UniformSubScopesProcessor();
       var layerAnalyzer = new Placeholder() { Name = "LayerAnalyzer (Placeholder)" };
@@ -176,5 +176,5 @@
 
       initializeAge.LeftSideParameter.ActualName = "EvalsCreated";
-      initializeAge.RightSideParameter.ActualName = "EvaluatedSolutions";
+      initializeAge.RightSideParameter.ActualName = "LocalEvaluatedSolutions";
 
       layerSorter.ValueParameter.ActualName = "Quality";
@@ -220,8 +220,8 @@
       resetTargetIndex.Successor = createRandomIndividual;
 
-      tryMoveUp.Successor = incrementEvaluations;
-
-      incrementEvaluations.ValueParameter.ActualName = "EvaluatedSolutions";
-      incrementEvaluations.Increment = new IntValue(1);
+      tryMoveUp.Successor = incrementLocalEvaluations;
+
+      incrementLocalEvaluations.ValueParameter.ActualName = "LocalEvaluatedSolutions";
+      incrementLocalEvaluations.Increment = new IntValue(1);
 
       incrementBatchIterations.ValueParameter.ActualName = "BatchIterations";
@@ -240,10 +240,10 @@
       incrIterations.ValueParameter.ActualName = "Iterations";
       incrIterations.Increment = new IntValue(1);
-      incrIterations.Successor = updateResultEvaluatedSolutions;
-
-      updateResultEvaluatedSolutions.ValueParameter.ActualName = "ResultEvaluatedSolutions";
-      updateResultEvaluatedSolutions.IncrementParameter.ActualName = "BatchSize";
-      updateResultEvaluatedSolutions.IncrementParameter.Value = null;
-      updateResultEvaluatedSolutions.Successor = layerAnalyzerProcessor;
+      incrIterations.Successor = updateEvaluatedSolutions;
+
+      updateEvaluatedSolutions.ValueParameter.ActualName = "EvaluatedSolutions";
+      updateEvaluatedSolutions.IncrementParameter.ActualName = "BatchSize";
+      updateEvaluatedSolutions.IncrementParameter.Value = null;
+      updateEvaluatedSolutions.Successor = layerAnalyzerProcessor;
 
       layerAnalyzerProcessor.Operator = layerAnalyzer;
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS.SteadyState/3.3/SteadyStateMatingPoolCreator.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS.SteadyState/3.3/SteadyStateMatingPoolCreator.cs	(revision 12259)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS.SteadyState/3.3/SteadyStateMatingPoolCreator.cs	(revision 12270)
@@ -71,5 +71,4 @@
       Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions"));
       Parameters.Add(new LookupParameter<IntValue>("PopulationSize"));
-
     }
 